'use strict'

import castPath from './castPath'
import last     from '../arrays/last'
import parent   from './parent'
import toKey    from './toKey'

/**
 * The base implementation of `unset`.
 * @private
 * @param {Object} object - The object to query.
 * @param {Array|string} path - The path of the property to unset.
 * @returns {boolean} Returns `true` if the property is deleted, else `false`.
 */
const baseUnset = ( object , path ) =>
{
    path = castPath( path , object ) ;
    object = parent( object , path ) ;
    return object === null || delete object[ toKey( last(path) ) ] ;
};

export default baseUnset ;